diff --git a/block/quorum.c b/block/quorum.c
index 0524b63..e157eb1 100644
--- a/block/quorum.c
+++ b/block/quorum.c
@@ -52,11 +52,166 @@ struct QuorumAIOCB {
     int vote_ret;
 };
 
+static int quorum_parse_uint_step_next(const char *start,
+                                       const char *name,
+                                       const char separator,
+                                       unsigned long long *value,
+                                       char **next)
+{
+    int ret;
+    if (start[0] == '\0') {
+        qerror_report(QERR_MISSING_PARAMETER, name);
+        return -EINVAL;
+    }
+    ret = parse_uint(start, value, next, 10);
+    if (ret < 0) {
+        qerror_report(QERR_INVALID_PARAMETER_TYPE, name, "int");
+        return ret;
+    }
+    if (**next != separator) {
+        qerror_report(ERROR_CLASS_GENERIC_ERROR,
+                      "%c separator required after %s",
+                      separator, name);
+        return -EINVAL;
+    }
+    *next += 1;
+    return 0;
+}
+
+/* Valid quorum resources look like
+ * quorum:threshold/total:path/to/image_1: ... :path/to/image_total
+ *
+ * ':' is used as a separator
+ * '\' is the escaping character for filename containing ':'
+ */
+static int quorum_open(BlockDriverState *bs, const char *filename, int flags)
+{
+    BDRVQuorumState *s = bs->opaque;
+    int i, j, k, len, ret = 0;
+    char *a, *b, *names;
+    const char *start;
+    bool escape;
+
+    /* Parse the quorum: prefix */
+    if (!strstart(filename, "quorum:", &start)) {
+        return -EINVAL;
+    }
+
+    /* Get threshold */
+    ret = quorum_parse_uint_step_next(start, "threshold", '/',
+                                      &s->threshold, &a);
+    if (ret < 0) {
+        return ret;
+    }
+
+    /* Get total */
+    ret = quorum_parse_uint_step_next(a, "total", ':', &s->total, &b);
+    if (ret < 0) {
+        return ret;
+    }
+
+    if (s->threshold < 1) {
+        qerror_report(QERR_INVALID_PARAMETER_VALUE, "threshold", "value >= 1");
+        return -ERANGE;
+    }
+
+    if (s->total < 2) {
+        qerror_report(QERR_INVALID_PARAMETER_VALUE, "total", "value >= 2");
+        return -ERANGE;
+    }
+
+    if (s->threshold > s->total) {
+        qerror_report(ERROR_CLASS_GENERIC_ERROR,
+                      "threshold <= total must be true");
+        return -ERANGE;
+    }
+
+    s->bs = g_malloc0(sizeof(BlockDriverState *) * s->total);
+    /* Two allocations for all filenames: simpler to free */
+    s->filenames = g_malloc0(sizeof(char *) * s->total);
+    names = g_strdup(b);
+
+    /* Get the filenames pointers */
+    escape = false;
+    s->filenames[0] = names;
+    len = strlen(names);
+    for (i = j = k = 0; i < len && j < s->total; i++) {
+        /* separation between two files */
+        if (!escape && names[i] == ':') {
+            char *prev = s->filenames[j];
+            prev[k] = '\0';
+            s->filenames[++j] = prev + k + 1;
+            k = 0;
+            continue;
+        }
+
+        escape = !escape && names[i] == '\\';
+
+        /* if we are not escaping copy */
+        if (!escape) {
+            s->filenames[j][k++] = names[i];
+        }
+    }
+    /* terminate last string */
+    s->filenames[j][k] = '\0';
+
+    if ((j + 1) != s->total) {
+        qerror_report(ERROR_CLASS_GENERIC_ERROR,
+                      "Number of provided file must be equal to total");
+        ret = -EINVAL;
+        goto free_exit;
+    }
+
+    /* Open files */
+    for (i = 0; i < s->total; i++) {
+        s->bs[i] = bdrv_new("");
+        ret = bdrv_open(s->bs[i], s->filenames[i], flags, NULL);
+        if (ret < 0) {
+            goto error_exit;
+        }
+    }
+
+    goto exit;
+
+error_exit:
+    for (; i >= 0; i--) {
+        bdrv_delete(s->bs[i]);
+        s->bs[i] = NULL;
+    }
+free_exit:
+    g_free(s->filenames[0]);
+    g_free(s->filenames);
+    s->filenames = NULL;
+    g_free(s->bs);
+exit:
+    return ret;
+}
+
+static void quorum_close(BlockDriverState *bs)
+{
+    BDRVQuorumState *s = bs->opaque;
+    int i;
+
+    for (i = 0; i < s->total; i++) {
+        /* Ensure writes reach stable storage */
+        bdrv_flush(s->bs[i]);
+        bdrv_delete(s->bs[i]);
+    }
+
+    g_free(s->filenames[0]);
+    g_free(s->filenames);
+    s->filenames = NULL;
+    g_free(s->bs);
+}
+
 static BlockDriver bdrv_quorum = {
     .format_name        = "quorum",
     .protocol_name      = "quorum",
 
     .instance_size      = sizeof(BDRVQuorumState),
+
+    .bdrv_file_open     = quorum_open,
+    .bdrv_close         = quorum_close,
 };
 
 static void bdrv_quorum_init(void)